--Create frame and register event.
local frame = CreateFrame("FRAME", "IWMFrame")
local main_frame = CreateFrame("frame", "ImmersiveWarfrontFrame", UIParent);
frame:RegisterEvent ("GOSSIP_SHOW")
local englishFaction, localizedFaction = UnitFactionGroup("player")
local continent = "whatever fpr now"
local modFaction = "blarg"
local highlightType = "blorg"
zones = {"Drustvar","Друствар",
		 "Stormsong","Das Sturmsangtal","Valle Canto Tormenta","Vallée Chantorage","Valle dei Sacraonda","Vale Trovamare","Долина Штормов",
		 "Tiragarde","Der Tiragardesund","Тирагардское поморье",
		 "Vol'Dun","Vol'dun","Вол'дун",
		 "Nazmir","Назмир",
		 "Zuldazar","Зулдазар"}
if englishFaction == "Horde" then
	continent = "KulTiras" --CHANGE AFTER TESTING
	modFaction = "horde"
	highlightType = "diamondhighlight"
else
	continent = "Zandalar"
	modFaction = "alliance"
	highlightType = "shieldhighlight"
end

--Make main frame
frame.main_frame = main_frame;
main_frame.background = main_frame:CreateTexture(nil, "HIGH");
main_frame.background:SetAllPoints();
main_frame.background:SetDrawLayer("BACKGROUND", 1);
main_frame.background:SetColorTexture(0, 0, 0, 0.7);
main_frame:EnableMouse(true)
main_frame:SetMovable(true)
main_frame:EnableKeyboard(true)
main_frame:SetPropagateKeyboardInput(true)
main_frame:RegisterForDrag("LeftButton")
main_frame:SetScript("OnMouseDown", main_frame.StartMoving)
main_frame:SetScript("OnMouseUp", main_frame.StopMovingOrSizing)

-- Set frame position
main_frame:ClearAllPoints();
main_frame:SetPoint("CENTER", UIParent, "CENTER", 0, 0);
main_frame:SetWidth(750);
main_frame:SetHeight(500);
main_frame:Hide();

--Make drustvar/vol'dun button
main_frame.drustvarButton = CreateFrame("Button","drustvar",main_frame)
if modFaction == "horde" then
	main_frame.drustvarButton:SetPoint("CENTER",main_frame,"CENTER", -142,-90)
else
	main_frame.drustvarButton:SetPoint("CENTER",main_frame,"CENTER", -95,56)
end

main_frame.drustvarButton:SetSize(50,55)
main_frame.drustvarButton:SetNormalTexture("\\Interface\\Garrison\\OrderHallLandingButtonHorde.blp")
main_frame.drustvarButton:SetPushedTexture("\\Interface\\Garrison\\OrderHallLandingButtonHorde.blp")
main_frame.drustvarButton:SetHighlightTexture("\\Interface\\Garrison\\OrderHallLandingButtonHorde.blp")
main_frame.drustvarButton:GetNormalTexture():SetAtlas("bfa-landingbutton-"..modFaction.."-up", true)
main_frame.drustvarButton:GetPushedTexture():SetAtlas("bfa-landingbutton-"..modFaction.."-down", true)
main_frame.drustvarButton:GetHighlightTexture():SetAtlas("bfa-landingbutton-"..modFaction.."-"..highlightType.."", true)
main_frame.drustvarButton:SetScript("OnClick", function(self) 
	if GossipFrame then
		SelectGossipOption(1)
		GossipFrame:SetAlpha(1)
		GossipTitleButton1:Enable()
		GossipTitleButton2:Enable()
		GossipTitleButton3:Enable()
		GossipFrame:EnableMouse(true)
		main_frame:Hide()
	end
end)
--Make Stormsong/Nazmir button
main_frame.stormsongButton = CreateFrame("Button","stormsong",main_frame)
if modFaction == "horde" then
	main_frame.stormsongButton:SetPoint("CENTER",main_frame,"CENTER", 62,135)
else
	main_frame.stormsongButton:SetPoint("CENTER",main_frame,"CENTER", 131,118)
end

main_frame.stormsongButton:SetSize(50,55)
main_frame.stormsongButton:SetNormalTexture("\\Interface\\Garrison\\OrderHallLandingButtonHorde.blp")
main_frame.stormsongButton:SetPushedTexture("\\Interface\\Garrison\\OrderHallLandingButtonHorde.blp")
main_frame.stormsongButton:SetHighlightTexture("\\Interface\\Garrison\\OrderHallLandingButtonHorde.blp")
main_frame.stormsongButton:GetNormalTexture():SetAtlas("bfa-landingbutton-"..modFaction.."-up", true)
main_frame.stormsongButton:GetPushedTexture():SetAtlas("bfa-landingbutton-"..modFaction.."-down", true)
main_frame.stormsongButton:GetHighlightTexture():SetAtlas("bfa-landingbutton-"..modFaction.."-"..highlightType.."", true)
main_frame.stormsongButton:SetScript("OnClick", function(self) 
	--Default behavior for 120
	if GossipFrame then
		SelectGossipOption(2)
		GossipFrame:SetAlpha(1)
		GossipTitleButton1:Enable()
		GossipTitleButton2:Enable()
		GossipTitleButton3:Enable()
		GossipFrame:EnableMouse(true)
		main_frame:Hide()
	end
end)

--Make Tiragarde/Zuldazar button
main_frame.tiragardeButton = CreateFrame("Button","tiragarde",main_frame)
if modFaction == "horde" then
	main_frame.tiragardeButton:SetPoint("CENTER",main_frame,"CENTER", 128,-50)
else
	main_frame.tiragardeButton:SetPoint("CENTER",main_frame,"CENTER", 73,-30)
end

main_frame.tiragardeButton:SetSize(50,55)
main_frame.tiragardeButton:SetNormalTexture("\\Interface\\Garrison\\OrderHallLandingButtonHorde.blp")
main_frame.tiragardeButton:SetPushedTexture("\\Interface\\Garrison\\OrderHallLandingButtonHorde.blp")
main_frame.tiragardeButton:SetHighlightTexture("\\Interface\\Garrison\\OrderHallLandingButtonHorde.blp")
main_frame.tiragardeButton:GetNormalTexture():SetAtlas("bfa-landingbutton-"..modFaction.."-up", true)
main_frame.tiragardeButton:GetPushedTexture():SetAtlas("bfa-landingbutton-"..modFaction.."-down", true)
main_frame.tiragardeButton:GetHighlightTexture():SetAtlas("bfa-landingbutton-"..modFaction.."-"..highlightType.."", true)
main_frame.tiragardeButton:SetScript("OnClick", function(self) 
	--Default behavior for 120
	if GossipFrame then
		SelectGossipOption(3)
		GossipFrame:SetAlpha(1)
		GossipTitleButton1:Enable()
		GossipTitleButton2:Enable()
		GossipTitleButton3:Enable()
		GossipFrame:EnableMouse(true)
		main_frame:Hide()
	end
end)

--Make exit button
main_frame.closeFrameButton = CreateFrame("Button","close",main_frame, "UIPanelButtonTemplate", 0)
main_frame.closeFrameButton:SetPoint("TOPRIGHT", main_frame, "TOPRIGHT", 0, 0)
main_frame.closeFrameButton:SetText("Close")
main_frame.closeFrameButton:SetScript("OnClick", function(self) 
	--Default behavior for 120
	if GossipFrame then
		GossipFrame:SetAlpha(1)
		GossipTitleButton1:Enable()
		GossipTitleButton2:Enable()
		GossipTitleButton3:Enable()
		main_frame:Hide()
		GossipFrame:EnableMouse(true)
		HideUIPanel(GossipFrame)
	end
end)
--Show original button
main_frame.showOriginalButton = CreateFrame("Button","showOriginal",main_frame, "UIPanelButtonTemplate", 0)
main_frame.showOriginalButton:SetPoint("BOTTOMRIGHT", main_frame, "BOTTOMRIGHT", 0, 0)
main_frame.showOriginalButton:SetText("Show Original")
main_frame.showOriginalButton:SetWidth(90)
main_frame.showOriginalButton:SetScript("OnClick", function(self) 
	--Default behavior for 120
	if GossipFrame then
		GossipFrame:SetAlpha(1)
		GossipTitleButton1:Enable()
		GossipTitleButton2:Enable()
		GossipTitleButton3:Enable()
		main_frame:Hide()
		GossipFrame:EnableMouse(true)
	end
end)
--Assign function to handle event
local function eventHandler(self, event, ...)
	if UnitName("npc") == "Dread-Admiral Tattersail"
	or UnitName("npc") == "Schreckensadmiralin Segelriss"
	or UnitName("npc") == "Almirante aterradora Velapastrosa"
	or UnitName("npc") == "Amiral de l'effroi Voguenille"
	or UnitName("npc") == "Ammiraglio del Terrore Velamesta"
	or UnitName("npc") == "Capitã do Medo Velarrota"
	or UnitName("npc") == "Жуткий адмирал Тэттерсейл"
	or UnitName("npc") == "Grand Admiral Jes-Tereth" 
	or UnitName("npc") == "Großadmiralin Jes-Tereth" 
	or UnitName("npc") == "Gran almirante Jes-Tereth" 
	or UnitName("npc") == "Grand amiral Jes-Tereth" 
	or UnitName("npc") == "Gran Ammiraglio Jes-Tereth" 
	or UnitName("npc") == "Grã-almirante Jes-Tereth" 
	or UnitName("npc") == "Верховный адмирал Джес-Терет" 
	then
		if GossipFrame then 
			GossipFrame:SetAlpha(0) --Change to 0 after testing
			GossipTitleButton1:Disable()
			GossipTitleButton2:Disable()
			GossipTitleButton3:Disable()
			GossipFrame:EnableMouse(false)
		end
		main_frame:Show()
		main_frame.drustvarButton:Hide()
		main_frame.stormsongButton:Hide()
		main_frame.tiragardeButton:Hide()
		local title1,gossip1,title2,gossip2,title3,gossip3 = GetGossipOptions()
		local gossipOptionsTable = {}
		table.insert(gossipOptionsTable, title1)
		table.insert(gossipOptionsTable, title2)
		table.insert(gossipOptionsTable, title3)
		for i=1,3 do
		   for j=1, #zones do
			  if gossipOptionsTable[i] ~= nil then 
				 if string.find(gossipOptionsTable[i],zones[j]) then
					if zones[j] == "Drustvar" or zones[j] == "Друствар" or zones[j] == "Vol'Dun" or zones[j] == "Vol'dun" or zones[j] == "Вол'дун" then
					   main_frame.drustvarButton:SetScript("OnClick",nil)
					   main_frame.drustvarButton:SetScript("OnClick", function(self)
							SelectGossipOption(i)
							GossipFrame:SetAlpha(1)
							if GossipTitleButton1 then GossipTitleButton1:Enable() end
							if GossipTitleButton2 then GossipTitleButton2:Enable() end
							if GossipTitleButton3 then GossipTitleButton3:Enable() end
							GossipFrame:EnableMouse(true)
							main_frame:Hide()
					   end)
					   main_frame.drustvarButton:Show()
					elseif zones[j] == "Stormsong" or zones[j] == "Das Sturmsangtal" or zones[j] == "Valle Canto Tormenta" or zones[j] == "Vallée Chantorage" or zones[j] == "Valle dei Sacraonda" or zones[j] == "Vale Trovamare" or zones[j] == "Долина Штормов"
						   or zones[j] == "Nazmir" or zones[j] == "Назмир" then
					   main_frame.stormsongButton:SetScript("OnClick",nil)
					   main_frame.stormsongButton:SetScript("OnClick", function(self)
							SelectGossipOption(i)
							GossipFrame:SetAlpha(1)
							if GossipTitleButton1 then GossipTitleButton1:Enable() end
							if GossipTitleButton2 then GossipTitleButton2:Enable() end
							if GossipTitleButton3 then GossipTitleButton3:Enable() end
							GossipFrame:EnableMouse(true)
							main_frame:Hide()
					   end)
					   main_frame.stormsongButton:Show()
					elseif zones[j] == "Tiragarde" or zones[j] == "Der Tiragardesund" or zones[j] == "Тирагардское поморье"
						   or zones[j] == "Zuldazar" or zones[j] == "Зулдазар" then
					   main_frame.tiragardeButton:SetScript("OnClick",nil)
					   main_frame.tiragardeButton:SetScript("OnClick", function(self)
							print("gossip option " ..i)
							SelectGossipOption(i)
							GossipFrame:SetAlpha(1)
							if GossipTitleButton1 then GossipTitleButton1:Enable() end
							if GossipTitleButton2 then GossipTitleButton2:Enable() end
							if GossipTitleButton3 then GossipTitleButton3:Enable() end
							GossipFrame:EnableMouse(true)
							main_frame:Hide()
					   end)
					   main_frame.tiragardeButton:Show()
					end
				 end
			  end
		   end
		end
	end
end

frame:SetScript("OnEvent", eventHandler)

main_frame:SetScript("OnKeyDown", function(self, button)
	main_frame:SetPropagateKeyboardInput(false)
	if button == "ESCAPE" then
		if main_frame and main_frame:IsShown() == true then
			if GossipFrame then 
				GossipFrame:SetAlpha(1)
				GossipFrame:EnableMouse(true)				
			end
			if GossipTitleButton1 then GossipTitleButton1:Enable() end
			if GossipTitleButton2 then GossipTitleButton2:Enable() end
			if GossipTitleButton3 then GossipTitleButton3:Enable() end
			main_frame:Hide()
		end
		if GossipFrame then HideUIPanel(GossipFrame) end
	end
	main_frame:SetPropagateKeyboardInput(true)
end)
for i=1,150 do 
	main_frame["tile"..i] = main_frame:CreateTexture("tile"..i,"HIGH")
	main_frame["tile"..i]:SetDrawLayer("ARTWORK", 1)
	main_frame["tile"..i]:SetWidth(50)
	main_frame["tile"..i]:SetHeight(50)
	main_frame["tile"..i]:SetTexture("Interface\\Worldmap\\"..continent.."\\"..continent..""..i..".blp", true)
end



local inc = 0
for x=1,10 do
	for j=1,15 do
		if (j+inc) == 1 then
			main_frame["tile"..(j+inc)]:SetPoint("TOPLEFT", main_frame,"TOPLEFT", 0,0)
		end
		if j == 1 and (x+inc)~= 1 then
			main_frame["tile"..(j+inc)]:SetPoint("TOPLEFT", main_frame["tile"..((inc-15)+1)],"BOTTOMLEFT")
		else
			if (j+inc)~=1 then
				main_frame["tile"..(j+inc)]:SetPoint("TOPLEFT", main_frame["tile"..((j+inc)-1)],"TOPRIGHT")
			end
		end
	end
	if inc ~= 150 then inc = inc + 15 end
end